//+------------------------------------------------------------------+
//|                                                            Graph |
//|                                 Copyright 2006-2012, FXmaster.de |
//|     programming & support - Alexey Sergeev (profy.mql@gmail.com) |
//+------------------------------------------------------------------+
#property copyright "Copyright 2006-2012, FXmaster.de"
#property link      "www.FXmaster.de"
#property version   "1.00"
#property library
//+------------------------------------------------------------------+
//| SetPoint                                                         |
//+------------------------------------------------------------------+
void SetPoint(long achart,string name,int awnd,int ax,int ay,color aclr) export
  {
   ObjectCreate(achart,name,OBJ_RECTANGLE_LABEL,awnd,0,0);
   ObjectSetInteger(achart,name,OBJPROP_CORNER,0);
   ObjectSetInteger(achart,name,OBJPROP_COLOR,aclr);
   ObjectSetInteger(achart,name,OBJPROP_BGCOLOR,aclr);
   ObjectSetInteger(achart,name,OBJPROP_XDISTANCE,ax);
   ObjectSetInteger(achart,name,OBJPROP_YDISTANCE,ay);
   ObjectSetInteger(achart,name,OBJPROP_XSIZE,2);
   ObjectSetInteger(achart,name,OBJPROP_YSIZE,1);
   ObjectSetInteger(achart,name,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(achart,name,OBJPROP_READONLY,true);
   ObjectSetInteger(achart,name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
  }
//+------------------------------------------------------------------+
//| SetLabel                                                         |
//+------------------------------------------------------------------+
void SetLabel(long achart,string name,int wnd,string text,color clr,
              int x,int y,int corn=0,int fontsize=8,string font="Tahoma") export
  {
   ObjectCreate(achart,name,OBJ_LABEL,wnd,0,0);
   ObjectSetInteger(achart,name,OBJPROP_CORNER,corn);
   ObjectSetString(achart,name,OBJPROP_TEXT,text);
   ObjectSetInteger(achart,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(achart,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetString(achart,name,OBJPROP_FONT,font);
   ObjectSetInteger(achart,name,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(achart,name,OBJPROP_BORDER_TYPE,0);
   ObjectSetInteger(achart,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(achart,name,OBJPROP_YDISTANCE,y);
   ObjectSetString(achart,name,OBJPROP_TOOLTIP,"");
   ObjectSetInteger(achart,name,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
  }
//+------------------------------------------------------------------+
//| SetEdit                                                          |
//+------------------------------------------------------------------+
void SetEdit(long achart,string name,int wnd,string text,color txtclr,color bgclr,color brdclr,
             int x,int y,int dx,int dy,int corn=0,int fontsize=8,string font="Tahoma",bool ro=false) export
  {
   ObjectCreate(achart,name,OBJ_EDIT,wnd,0,0);
   ObjectSetInteger(achart,name,OBJPROP_CORNER,corn);
   ObjectSetString(achart,name,OBJPROP_TEXT,text);
   ObjectSetInteger(achart,name,OBJPROP_COLOR,txtclr);
   ObjectSetInteger(achart,name,OBJPROP_BGCOLOR,bgclr);
   ObjectSetInteger(achart,name,OBJPROP_BORDER_COLOR,brdclr);
   ObjectSetInteger(achart,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetString(achart,name,OBJPROP_FONT,font);
   ObjectSetInteger(achart,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(achart,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(achart,name,OBJPROP_XSIZE,dx);
   ObjectSetInteger(achart,name,OBJPROP_YSIZE,dy);
   ObjectSetInteger(achart,name,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(achart,name,OBJPROP_READONLY,ro);
   ObjectSetInteger(achart,name,OBJPROP_BORDER_TYPE,0);
   ObjectSetString(achart,name,OBJPROP_TOOLTIP,"");
  }
//+------------------------------------------------------------------+
//| SetButton                                                        |
//+------------------------------------------------------------------+
void SetButton(long achart,string name,int wnd,string text,color txtclr,color bgclr,
               int x,int y,int dx,int dy,int corn=0,int fontsize=8,string font="Tahoma",bool state=false) export
  {
   ObjectCreate(achart,name,OBJ_BUTTON,wnd,0,0);
   ObjectSetInteger(achart,name,OBJPROP_CORNER,corn);
   ObjectSetString(achart,name,OBJPROP_TEXT,text);
   ObjectSetInteger(achart,name,OBJPROP_STATE,state);
   ObjectSetInteger(achart,name,OBJPROP_COLOR,txtclr);
   ObjectSetInteger(achart,name,OBJPROP_BGCOLOR,bgclr);
   ObjectSetInteger(achart,name,OBJPROP_BORDER_COLOR,clrNONE);
   ObjectSetInteger(achart,name,OBJPROP_FONTSIZE,fontsize);
   ObjectSetString(achart,name,OBJPROP_FONT,font);
   ObjectSetInteger(achart,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(achart,name,OBJPROP_YDISTANCE,y);
   ObjectSetInteger(achart,name,OBJPROP_XSIZE,dx);
   ObjectSetInteger(achart,name,OBJPROP_YSIZE,dy);
   ObjectSetInteger(achart,name,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(achart,name,OBJPROP_BORDER_TYPE,0);
   ObjectSetString(achart,name,OBJPROP_TOOLTIP,"");
  }
//+------------------------------------------------------------------+
//| ObjectsDeleteAll2                                                |
//+------------------------------------------------------------------+
void ObjectsDeleteAll2(long achart=0,int wnd=-1,int type=-1,string pref="",string excl="") export
  {
   string names[];
   int i,n=ObjectsTotal(achart,wnd,type);
   ArrayResize(names,n);
   for(i=0; i<n; i++) names[i]=ObjectName(achart, i);
   for(i=0; i<n; i++)
     {
      if(pref!="") if(StringFind(names[i], pref)!=0) continue;
      if(excl!="") if(StringFind(names[i], excl)==0) continue;
      ObjectDelete(achart,names[i]);
     }
  }
//+------------------------------------------------------------------+
//| HideChart                                                        |
//+------------------------------------------------------------------+
void HideChart(long achart,color BackClr) export
  {
   ChartSetInteger(achart,CHART_SHOW_OHLC,false);
   ChartSetInteger(achart,CHART_SHOW_BID_LINE,false);
   ChartSetInteger(achart,CHART_SHOW_ASK_LINE,false);
   ChartSetInteger(achart,CHART_SHOW_LAST_LINE,false);
   ChartSetInteger(achart,CHART_SHOW_PERIOD_SEP,false);
   ChartSetInteger(achart,CHART_SHOW_GRID,false);
   ChartSetInteger(achart,CHART_SHOW_VOLUMES,CHART_VOLUME_HIDE);
   ChartSetInteger(achart,CHART_SHOW_OBJECT_DESCR,false);
   ChartSetInteger(achart,CHART_SHOW_TRADE_LEVELS,false);
   ChartSetInteger(achart,CHART_SHOW_DATE_SCALE,false);
   ChartSetInteger(achart,CHART_SHOW_PRICE_SCALE,false);
   ChartSetInteger(achart,CHART_FOREGROUND,false);
   ChartSetInteger(achart,CHART_SHIFT,false);
   ChartSetInteger(achart,CHART_MODE,CHART_LINE);
   ChartSetInteger(achart,CHART_SCALE,0);
   ChartSetInteger(achart,CHART_COLOR_BACKGROUND,BackClr);
   ChartSetInteger(achart,CHART_COLOR_FOREGROUND,BackClr);
   ChartSetInteger(achart,CHART_COLOR_CHART_LINE,BackClr);
   ChartSetInteger(achart,CHART_COLOR_ASK,BackClr);
   ChartSetInteger(achart,CHART_COLOR_BID,BackClr);
   ChartSetString(achart,CHART_COMMENT,"");
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
