//+------------------------------------------------------------------+
//|                                                            Spiro |
//|                                 Copyright 2006-2012, FXmaster.de |
//|     programming & support - Alexey Sergeev (profy.mql@gmail.com) |
//+------------------------------------------------------------------+
#property copyright "Copyright 2006-2012, FXmaster.de"
#property link      "www.FXmaster.de"
#property version   "1.00"

//--- importing some functions
#import "..\Experts\Spiro\Graph.ex5" 
void SetLabel(long achart,string name,int wnd,string text,color clr,
              int x,int y,int corn=0,int fontsize=8,string font="Tahoma");
void SetEdit(long achart,string name,int wnd,string text,color txtclr,color bgclr,color brdclr,
             int x,int y,int dx,int dy,int corn=0,int fontsize=8,string font="Tahoma",bool ro=false);
void SetButton(long achart,string name,int wnd,string text,color txtclr,color bgclr,
               int x,int y,int dx,int dy,int corn=0,int fontsize=8,string font="Tahoma",bool state=false);
void HideChart(long achart,color BackClr);
#import

//--- including the chart class
#include "Spiro.mqh" 

#import "..\Experts\Spiro\ISpiro.ex5"
CSpiro *iSpiro();
#import

//--- chart object instance
CSpiro *spiro;
//--- prefix for chart objects and Spiro
string sID;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
void OnInit()
  {
   HideChart(0,clrWhite);
   sID="spiro.";
   DrawParam();

   spiro=iSpiro();
//--- initializing the drawing
   spiro.Init(250,200,clrBlack,sID);
//--- setting the calculation parameters
   spiro.SetData(100,30,40,0.04,10);
   spiro.DrawSpiro();
  }
//+------------------------------------------------------------------+
//| DrawParam                                                        |
//+------------------------------------------------------------------+
void DrawParam()
  {
   color bgclr=clrWhite,clr=clrBlack;
//--- bigger radius
   SetLabel(0,sID+"stR.",0,"R",clr,10,10+3);
   SetEdit(0,sID+"R.",0,"100",clr,bgclr,clr,40,10,50,20);
//--- smaller radius
   SetLabel(0,sID+"str.",0,"r",clr,10,35+3);
   SetEdit(0,sID+"r.",0,"30",clr,bgclr,clr,40,35,50,20);
//--- distance to the center
   SetLabel(0,sID+"stD.",0,"D",clr,10,60+3);
   SetEdit(0,sID+"D.",0,"40",clr,bgclr,clr,40,60,50,20);
//--- drawing accuracy
   SetLabel(0,sID+"stA.",0,"Alfa",clr,10,85+3);
   SetEdit(0,sID+"A.",0,"0.04",clr,bgclr,clr,40,85,50,20);
//--- drawing accuracy
   SetLabel(0,sID+"stN.",0,"Rotor",clr,10,110+3);
   SetEdit(0,sID+"N.",0,"10",clr,bgclr,clr,40,110,50,20);
//--- draw button
   SetButton(0,sID+"draw.",0,"DRAW",bgclr,clr,39,135,51,20);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- deleting the object
   delete spiro;
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
//--- if the draw button has been clicked, update the chart
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(sparam==sID+"draw.")
        {
         ObjectSetInteger(0,sparam,OBJPROP_STATE,0);
         spiro.DrawSpiro();
        }
     }

//--- if the chart parameters have been changed, update the chart
   if(id==CHARTEVENT_OBJECT_ENDEDIT)
     {
      if(sparam==sID+"R.") spiro.m_R=StringToDouble(ObjectGetString(0, sparam, OBJPROP_TEXT));
      if(sparam==sID+"r.") spiro.m_r=StringToDouble(ObjectGetString(0, sparam, OBJPROP_TEXT));
      if(sparam==sID+"D.") spiro.m_D=StringToDouble(ObjectGetString(0, sparam, OBJPROP_TEXT));
      if(sparam==sID+"A.") spiro.m_dAlfa=StringToDouble(ObjectGetString(0, sparam, OBJPROP_TEXT));
      if(sparam==sID+"N.") spiro.m_nRotate=StringToDouble(ObjectGetString(0, sparam, OBJPROP_TEXT));
      spiro.DrawSpiro();
     }
  }
//+------------------------------------------------------------------+
